# Galton-Brett: Aufgabe 9.3
# Gerhard Bitsch, August 2008

# Galton simuliert ein Galton-Brett. An jedem Baum wird per Zufallsgenerator
# entschieden. ob Kara nach links oder rechts geht. Hat Kara die Baumreihen
# durchlaufen, legt er am unteren Rand der Spalte, in der er ist, ein Blatt ab.
# Die Anzahlen der Bltter in den einzelnen Spalten realisieren eine binomial-
# verteilte Zufallsvariable.


  # pos zhlt die Differenz der Sprnge nach Links und Rechts
  # fertig wird verwendet, um das Ende eines Durchgangs zu markieren
  @pos=0;
  @fertig=false;

  # weiter simuliert einen Schritt bei einem Durchgang
  # bei jedem Baum wird per Zufallsgenerator entschieden, ob nach
  # links oder rechts gegangen wird
  def weiter
    if @kara.treeFront then
      if @tools.random(1)>0 then
        @kara.turnRight
        @kara.move
        @kara.turnLeft
        @pos -=1
      else 
        @kara.turnLeft
        @kara.move
        @kara.turnRight
        @pos += 1
      end
      @kara.move
      @kara.move
    # ist das Ende der Baumreihen erreicht, geht es zum unteren Rand
    # um ein Blatt abzulegen
    else 
      @fertig=true
      # Spalte abwrts bis zu Blatt oder Baum
      @kara.move while not(@kara.onLeaf or @kara.treeFront) 
      if not @kara.onLeaf  #erstes Blatt der Spalte
        @kara.putLeaf
      else                        # schon ein Blatt da
        2.times {@kara.turnLeft}  # also 1 hher
        @kara.move
        @kara.putLeaf             # neues Blatt
      end
    end
  end

  # eine allgemeine Methode zur Erzeugung des Brettes
  #  maxX:   Anzahl der Spalten der Welt
  #  maxY:   Anzahl der Reihen der Welt
  #  reihen: Anzahl der Baumreihen
  def generateWorld(maxX,maxY,reihen) 
    @world.setSize(maxX,maxY)
    @world.clearAll
    # jetzt die Baumreihen mit doppelter Schleife
    # die uere Schleife iteriert ber die Reihen
    # die ite Reihe hat i Bume, deshalb j<=i in der inneren Schleife
    y=1;
    x=maxX/2; # Spitze in der Mitte
    (reihen+1).times do |i|
      (i+1).times do |j|
        # immer eine Leerzeile zwischen zwei Reihen: y+2*i
        # zwischen 2 Bumen ein leeres Feld und
        # bei jeder Reihe eins weiter vorn anfangen
        @world.setTree(x-i+2*j,y+2*i,true)
      end
    end
    # zum Schluss den unteren Rand bepflanzen
    maxX.times {|i| @world.setTree(i,maxY-1,true)}
  end


 SPALTEN=23;
 REIHEN=100;
 BAUMREIHEN=10;
 VERSUCHE=200;
 generateWorld(SPALTEN,REIHEN,BAUMREIHEN);
 VERSUCHE.times do  
    @kara.setPosition(SPALTEN/2,0)
    @kara.setDirection(2)
    @pos=0;
    @fertig=false;
    weiter  while not @fertig
    @kara.setPosition(0,0);
  end



